/******************************************************************************/
/*!
 * \file timlCNNLinearParamsDefault.c
 */
/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************/


/*******************************************************************************
 *
 * INCLUDES
 *
 ******************************************************************************/

#include "../api/timl.h"

/*******************************************************************************/
/*!
 * \ingroup cnn
 * \brief   Return the default parameters for the linear layer
 * \return  Default linear layer parameters
 */
/*******************************************************************************/

timlCNNLinearParams timlCNNLinearParamsDefault()
{
   timlCNNLinearParams params;
   params.dim                  = -1;
   params.prevDim              = -1;
   params.weight               = NULL; // prevDim * dim
   params.weightInc            = NULL;
   params.weightGradAccum      = NULL;
   params.bias                 = NULL; // dim * 1
   params.biasInc              = NULL;
   params.biasGradAccum        = NULL;
   params.weightDecayFactor    = 1.0;
   params.weightLearningFactor = 1.0;
   params.weightInit.type      = Util_Xavier;
   params.weightInit.mean      = 0.0;
   params.weightInit.std       = 0.001;
   params.biasLearningFactor   = 1.0;
   params.biasInit.type        = Util_Constant;
   params.biasInit.val         = 0.0;
   params.shared               = false;

   return params;
}

